
%if 0

lDebug initialisation

Copyright (C) 1995-2003 Paul Vojta
Copyright (C) 2008-2012 C. Masloch

Usage of the works is permitted provided that this
instrument is retained with the works, so that any entity
that uses the works is notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

%endif

		; Macros to handle code which requires the cs: prefix if
		; we might be loaded as boot loader. (This prefix doesn't
		; harm loading as DOS program, but isn't required either.)
%if _BOOTLDR
%define BOOTLDR_cs cs
%define BOOTLDR_cs_ cs:
%else
%define BOOTLDR_cs
%define BOOTLDR_cs_
%endif


initcont:
	mov ah, 4Ah
	mov bx, resimagepsp_size_p
	int 21h				; resize to required
;	jc ...				; (expected to work since it had to be larger. also we hooked ints)
.resized:
	cli
	mov sp, stack_end		; stack pointer (paragraph aligned)
	mov word [ savesp ], stack_end-2; save new SP minus two (for the word we'll push)
..@init_first equ line_in.end
; ..@init_behind equ trim_overflow
..@init_behind equ stack
	mov di, ..@init_first
	mov cx, ..@init_behind - ..@init_first
	xor ax, ax
	rep stosb			; initialise breakpoint lists, line_out, auxbuff
%if 1
%if ..@init_behind != stack
	mov di, stack
%endif
	mov cx, stack_end - stack
	mov al, 5Eh
	rep stosb			; initialise the stack
%endif
	mov byte [ trim_overflow ], '0'	; initialise line_out so the trimputs loop doesn't overflow

		; Save, then modify termination address and parent PSP.
	mov si, TPIV
	mov di, psp22
	movsw
	movsw				; save Int22
	mov dx, debug22
	mov word [ si-4 ], dx
	mov word [ si-2 ], ds		; set pspInt22 (required)
	mov si, 16h
	movsw				; save parent
	mov word [ si-2 ], ds		; set pspParent
	call getint2324			; init run2324 to avoid using or displaying NUL vectors
	sti
	mov si, cmd3
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jz .set22
	push ds
	push si
	retf				; directly jump to cmd3 of the installed image
.set22:
%endif
	mov ax, 2522h			; set Int22
	int 21h				; (not really required)
	push si				; this avoids the need to return here later so that ll3 is
					; free to overwrite line_in and line_out
	jmp ll3				; load a program if one has been given at the command line

	numdef _USE_FINAL__
%assign __CHECK_ENDOFINITCONT $+SECTIONFIXUP
%if __NASM_VERSION_ID__ >= 020A0000h && __USE_FINAL__
		; Insure that initcont is completely within the input buffer.
		; This is important because the buffers behind line_in will
		; be initialised in initcont, and so it would otherwise crash.
%final %endif
%final  %error end of initcont (%[__CHECK_ENDOFINITCONT]) >= \
		..@init_first (%[__CHECK_INITFIRST]), initcont overwrites itself
%final %if __CHECK_ENDOFINITCONT >= __CHECK_INITFIRST
%final %assign __CHECK_INITFIRST ..@init_first+SECTIONFIXUP
%final section DATASTACK
%endif



%macro __writepatchtable2 0-*.nolist
%if %0 & 1
 %fatal Expected even number of arguments
%endif
%rep %0 >> 1
	%1 %2
%rotate 2
%endrep
%endmacro

%macro __patchtable2_entry 0.nolist
  ; only if this isn't the first (pseudo-)entry
  %if %$lastcount != 0
   ; if the offset from %$previous is less than 255
   %if (%$last-%$previous) < 255
    %assign %$$method2tablesize %$$method2tablesize+1
    ; then write a single byte (number of bytes not to patch between)
    %xdefine %$$method2list %$$method2list,db,%$last-%$previous
   %else
    ; otherwise write a 255 ("reposition") and write the 16-bit address afterwards
    %assign %$$method2tablesize %$$method2tablesize+3
    %xdefine %$$method2list %$$method2list,db,255,dw,%$last
   %endif
   %if %$lastcount == 1
    %assign %$onecount %[%$onecount]+1
   %endif
   %assign %$$method2tablesize %$$method2tablesize+1
   ; and write the number of bytes to be patched
   %xdefine %$$method2list %$$method2list,db,%$lastcount
   ; define %$previous for the next entry: it points to the next non-patched byte
   %define %$previous (%[%$last]+%[%$lastcount])
  %endif
%endmacro

%macro writepatchtable 2-*.nolist

%push
		; Determine length of simple table:
%assign %$method1tablesize (%0 - 2)*2
		; Determine length of complicated table:
%assign %$method2tablesize 0
%define %$method2list db,""
%push
;%define %$previous start	; if list contains labels
%define %$previous 256
%define %$last %[%$previous]
%assign %$lastcount 0
%assign %$onecount 0
%rotate 1
%rep %0 - 2
 %rotate 1
 ;if  it continues the previous patch   and not too long   and this isn't the first
 %if ((%$last+%$lastcount) == %1) && (%$lastcount < 255) && (%$lastcount != 0)
  ; then do not write an entry, just increase the patch's size
  %assign %$lastcount %[%$lastcount]+1
 %else
  ; otherwise write the last entry
  __patchtable2_entry
  ; define new %$last to this parameter, %$lastcount to one
  %define %$last %1
  %assign %$lastcount 1
 %endif
%endrep
__patchtable2_entry

; at the end, there's a patch with offset 0, size 0
%assign %$$method2tablesize %$$method2tablesize+2
%xdefine %$$method2list %$$method2list,db,0,db,0

%assign %$$onecount %$onecount
%pop
%rotate 1

%if %$method1tablesize > (%$method2tablesize+20)
 %define __%{1}_method 2
%else
 %define __%{1}_method 1
%endif


%1:
%if __%{1}_method == 2
	__writepatchtable2 %$method2list
	endarea %1
%assign %$size %1_size
%warning %1: %$size bytes
%warning (Method 2, %$onecount one-byte patches)
%else
%rotate 1
%rep %0 - 2
%rotate 1
	dw %1
%endrep
%rotate 1
	endarea %1
%assign %$size %1_size
%warning %1: %$size bytes
%warning (Method 1)
%endif
%pop
%endmacro

	;align 2			; align on word boundary
    times (2 - ($+SECTIONFIXUP) % 2) % 2 nop

		; Table of patches that are to be set NOP if not running on a 386.
writepatchtable patch_no386_table, PATCH_NO386_TABLE
%undef PATCH_NO386_TABLE 

		; Table of patches that are to be set NOP if running on a 386.
writepatchtable patch_386_table, PATCH_386_TABLE
%undef PATCH_386_TABLE

%unmacro __writepatchtable2 0-*.nolist
%unmacro __patchtable2_entry 0.nolist
%unmacro writepatchtable 2-*.nolist


%if _BOOTLDR
ebdaflag:	db 0		; EBDA flag: non-zero if present

	; Image identification
	; First dword: signature
	; Next word: version, two ASCII digits
	; Next word: checksum. adding up all words of the paragraph gives zero
	; Next word: size of image (including this paragraph)
	; Three words reserved, zero.
imageident:
	db "NDEB00"
[warning -number-overflow]
	dw -("ND"+"EB"+"00"+kib(resimagepsp_size+16)*64)
[warning *number-overflow]
	dw kib(resimagepsp_size+16)*64
	times 3 dw 0
%endif

imsg:
.help:	db _PROGNAME,_VERSION,", debugger.",13,10
	db 13,10
	db "Usage: ",_FILENAME,"[.COM] [[drive:][path]progname.ext [parameters]]",13,10
	db 13,10
	db "  progname.ext",9,9,"(executable) file to debug or examine",13,10
	db "  parameters",9,9,	"parameters given to program",13,10
	db 13,10
	db "For a list of debugging commands, run ",_FILENAME," and type ? at the prompt.",13,10
	asciz
%if _ONLY386
.no386:	ascizline "Error: This ",_PROGNAME," build requires a 386 CPU or higher."
%elif _ONLYNON386
.386:	asciiline "Warning: This ",_PROGNAME," build is ignorant of 386 CPU specifics."
	ascizline 9," It does not allow access to the available 386-specific registers!"
%endif

.invalidswitch:
	db "Invalid switch - "
.invalidswitch_a:
	asciz "x",13,10
%if _BOOTLDR
.booterror:
	asciz 13,10,"Boot error. Press any key to reboot.",13,10
%endif
%if _DOSEMU && _PM
.dosemudate:	db "02/25/93"
%endif
..@tempstack:
%if _VDD
.vdd:		asciz "DEBXXVDD.DLL"
.dispatch:	asciz "Dispatch"
.init:		asciz "Init"
.mouse:		db "MOUSE",32,32,32		; Looks like a device name
.andy:		db "Andy Watson"		; I don't know him and why he's inside the NTVDM mouse driver
	endarea .andy
.ntdos:		db "Windows NT MS-DOS subsystem Mouse Driver"	; Int33.004D mouse driver copyright string (not ASCIZ)
	endarea .ntdos

		; INP:	-
		; OUT:	CY if not NTVDM
		;	NC if NTVDM
		;	ds = es = cs
		; CHG:	ax, bx, cx, dx, di, si, bp, es, ds
isnt:
		mov ax, 5802h			; Get UMB link state
		int 21h
		xor ah, ah
		push ax				; Save UMB link state
		mov ax, 5803h			; Set UMB link state:
		mov bx, 1			;  Add UMBs to memory chain
		int 21h
		mov ah, 52h
		mov bx, -1
		int 21h				; Get list of lists
		inc bx				; 0FFFFh ?
		jz .notnt			; invalid -->
		mov ax, word [es:bx-3]		; First MCB
		push cs
		pop es				; reset es
.loop:
		mov ds, ax			; ds = MCB
		inc ax				; Now segment of memory block itself
		xor dx, dx
		xor bx, bx
		cmp byte [bx], 'Z'		; End of MCB chain?
		jne .notlast
		inc dx
		jmp short .notchain
 .notlast:
		cmp byte [bx], 'M'		; Valid MCB chain?
		jne .error
 .notchain:
		mov cx, [bx+3]			; MCB size in paragraphs
				; ax = current memory block
				; cx = size of current memory block in paragraphs
				; dx = flag whether this is the last MCB
				; ds = current MCB (before memory block)
		cmp word [bx+1], 8		; MCB owner DOS?
		jne .notfound_1
		cmp word [bx+8], "SD"		; MCB name "SD"?
		jne .notfound_1
.loopsub:
		mov ds, ax			; SD sub-segment inside memory block
		inc ax
		dec cx
		mov bp, word [bx+3]		; Paragraphs 'til end of SD sub-segment
				; ax = current SD sub-segment
				; cx = paragraphs from SD sub-segment start (ax) to current memory block end
				; ds = current SD sub-MCB (like MCB, but for SD sub-segment)
				; bp = current SD sub-segment size in paragraphs
		cmp cx, bp
		jb .notfound_1			; Goes beyond memory block, invalid -->
		cmp byte [bx], 'Q'		; NTVDM type 51h sub-segment ?
		jne .notfound_2			; no -->
		mov si, 8			; Offset of device name (if SD device driver sub-segment)
		mov di, imsg.mouse
		push cx
		mov cx, si			; length of name
		repe cmpsb			; blank-padded device name "MOUSE" ?
		pop cx
		jne .notfound_2			;  Device name doesn't match, try next SD sub-segment
		mov ax, ds
		inc ax
		mov ds, ax			; Segment of SD sub-segment
				; ds = current SD sub-segment
		mov ax, bp			; Leave paragraph value in bp
		test ax, 0F000h			; Would *16 cause an overflow?
		jnz .notfound_3			;  Then too large -->
		push cx
		mov cl, 4
		shl ax, cl			; *16
		pop cx
				; ax = current SD sub-segment size in byte
.andy:
		mov di, imsg.andy
		push cx
		mov cx, imsg.andy_size
		call findstring			; String "Andy Watson"?
		pop cx
		jc .notfound_3
.ntdos:
		mov di, imsg.ntdos
		push cx
		mov cx, imsg.ntdos_size
		call findstring			; String "Windows NT MS-DOS subsystem Mouse Driver"?
		pop cx
		jnc .found			; (NC)
.notfound_3:
		mov ax, ds
.notfound_2:
		cmp cx, bp
		je .notfound_1			; End of SD memory block, get next MCB
		add ax, bp			; Address next SD sub-MCB
		sub cx, bp
		jmp short .loopsub		; Try next SD sub-segment
.notfound_1:
		add ax, cx			; Address next MCB
		test dx, dx			; Non-zero if 'Z' MCB
		jz .loop			; If not at end of MCB chain, try next
		; jmp short .notnt		;  Otherwise, not found
 .error:
 .notnt:
		stc
.found:
		push cs
		pop ds				; restore ds

		pop bx				; saved UMB link state
		mov ax, 5803h
		pushf
		int 21h				; Set UMB link state
		popf
		retn

findstring:
		xor si, si
.loop:
		push si
		add si, cx
		jc .notfound_c
		dec si				; The largest offset we need for this compare
		cmp ax, si
 .notfound_c:
		pop si
		jb .return			; Not found if at top of memory block -->
		push di
		push si
		push cx
		repe cmpsb			; String somewhere inside program?
		pop cx
		pop si
		pop di
		je .return			;  Yes, proceed --> (if ZR, NC)
		inc si				; Increase pointer by one
		jmp short .loop			;  Try next address
.return:
		retn
%endif

%if _BOOTLDR
		; Move paragraphs
		;
		; INP:	ax:0-> source
		;	dx:0-> destination
		;	cx = number of paragraphs
		; CHG:	-
		; OUT:	NC
		; Note:	Doesn't work correctly on HMA; doesn't always wrap to LMA either.
		;	Do not provide a wrapped/HMA source or destination!
movp:
	push cx
	push ds
	push si
	push es
	push di

	cmp ax, dx		; source below destination ?
	jb .down		; yes, move from top down -->
	je .return		; same, no need to move --> (NC)

	push ax
	push dx
.uploop:
	mov ds, ax
	mov es, dx
	xor di, di
	xor si, si		; -> start of segment
	sub cx, 1000h		; 64 KiB left ?
	jbe .uplast		; no -->
	push cx
	mov cx, 10000h /2
	rep movsw		; move 64 KiB
	pop cx
	add ax, 1000h
	add dx, 1000h		; -> next segment
	jmp short .uploop	; proceed for more -->
.uplast:
	add cx, 1000h		; restore counter
	shl cx, 1
	shl cx, 1
	shl cx, 1		; *8, paragraphs to words (NC)
	rep movsw		; move last part
	pop dx
	pop ax
	jmp short .return

.down:
	std
.dnloop:
	sub cx, 1000h		; 64 KiB left ?
	jbe .dnlast		; no -->
	push ax
	push dx
	add ax, cx
	add dx, cx
	mov ds, ax		; -> 64 KiB not yet moved
	mov es, dx
	pop dx
	pop ax
	mov di, -2
	mov si, di		; moved from last word down
	push cx
	mov cx, 10000h /2
	rep movsw		; move 64 KiB
	pop cx
	jmp short .dnloop	; proceed for more -->
.dnlast:
	add cx, 1000h		; restore counter
	shl cx, 1
	shl cx, 1
	shl cx, 1		; *8, paragraphs to words
	mov di, cx
	dec di
	shl di, 1		; words to offset, -> last word (NC)
	mov si, di
	mov ds, ax
	mov es, dx		; first segment correct
	rep movsw		; move first part
	cld
.return:
	pop di
	pop es
	pop si
	pop ds
	pop cx
	retn
%endif

		; Initial entry.
initcode:
	cld
%if _BOOTLDR
	call .iptest
.iptest:
	pop ax
	sub ax, .iptest
	jz .comentry
	cmp ax, -100h
	jne $
	mov ax, cs
	sub ax, 10h			; adjust as if we had a PSP
	push ax
	push ax
	mov ax, .bootentry
	push ax
	retf
.bootentry:
	pop ss
	mov sp, (..@bootentrystack+SECTIONFIXUP)&~1

		; Our loader transfers control to us with these registers:
		; INP:	ds:si-> INIT0DATA structure for INIT1
		;	cs:ip-> INIT1 and loaded image (ip = 0)
		;	 using i0LastMCB INIT1 can compute how large the image is
		;	ss:sp-> 512-byte stack
		;	other registers unspecified
		; STT:	EI, UP
		;	all interrupts left from BIOS
	setopt [ss:internalflags], nodosloaded
	clropt [ss:internalflags], notstdinput|inputfile|notstdoutput|outputfile
	mov byte [ss:notatty], 0	; it _is_ a tty
	push ds
	push ss
	pop ds
	push ss
	pop es
	mov al, 13
	call putc
	mov al, 10
	call putc
	pop ds
	mov di, init0data
	mov cx, -INIT0DATA_size
	cmp si, cx
	ja .noi0data
	neg cx
	cmp word [ si ], cx
	je .i0data
.noi0data:
.booterror:
	xor ax, ax
	db __TEST_IMM16			; (skip mov)
.hardbooterror:
	mov al, 1
d4	call d4dumpregs
	push ss
	pop ds
	push ss
	pop es
	push ax
	mov dx, imsg.booterror
	call putsz
	call getc
	pop ax
	test ax, ax
	jnz .hard
	int 19h
.hard:
	jmp 0FFFFh:0

.i0data:
	rep movsb
	push cs
	pop ds
	cmp byte [ init0data + i0RPLCreateMCB ], cl
	je .norpl
	jmp .booterror
		; notes for +RPL installation:
		; 1. Allocate enough memory for our MCB + an PSP + our image + the last and the RPL MCB
		; 2. Create the RPL's MCB + a last MCB
		; 3. Relocate, initialise PSP
		; 4. Hook Int2F as RPLOADER to report DOS our new size

.norpl:
%if 0
	mov ah, 0C1h
	stc
	int 15h				; BIOS, do you have an EBDA?
	mov ax, es
	jnc .ebda			; segment in ax -->
					; I don't believe you, let's check
%endif	; Enabling this would enable the BIOS to return an EBDA even if it isn't
	; noted at 40h:0Eh, which would be useless because we have to relocate it.
	mov bx, word [ init0data+i0LastMCB ]
	xor dx, dx
	inc bx				; -> behind usable memory
	mov ax, 40h
	mov es, ax
	mov ax, word [ es:0Eh ]		; EBDA segment (unless zero) or LPT4 base I/O address (200h..3FCh)
	cmp ax, 400h
	jb .noebda			; -->
.ebda:
d4	call d4message
d4	asciz "EBDA detected; press any key",13,10
d4	call d4pauseforkey
	inc byte [ ebdaflag ]
	cmp ax, bx
	;jb .booterror			; uhh, the EBDA is inside our memory?
	;ja .booterror			; EBDA higher than top of memory. This is just as unexpected.
	jne .hardbooterror

		; We'll first move us down, then the EBDA to its final position
		; and then us to above that, to our final position.

		; We could decide to only work with a smaller part of the EBDA,
		; but there are BIOSes to use more than 48 byte of that KiB.
		; Wouldn't really help much anyway.
	mov ds, ax
	xor dx, dx
	mov dl, byte [ 0 ]		; EBDA size in KiB
	mov cl, 6
	shl dx, cl			; *64, to paragraphs
.noebda:
	mov cx, dx			; cx = EBDA size
	add dx, bx			; dx-> behind EBDA
	jbe .hardbooterror		; now that is just silly --> (jbe = j CF || ZF)

	push cx
	push bx
	mov bx, dx			; bx-> behind EBDA
	mov ax, cx			; ax = EBDA size
	mov cx, imagepsp_size_p		; cx = init image size
	sub bx, kib(resimagepsp_size+16)*64	; where to relocate us to
	xor si, si
	xor di, di
	neg ax				; ax = - EBDA size
	mov dx, cs
	add ax, cx			; ax = init image size - EBDA size
	sbb si, si			; si = -1 if EBDA larger than init image
	add ax, byte 1			; ax++
	sbb di, di			; di = -1 if EBDA as large as init image
	sub dx, cx			; cs - image size
	jbe .booterror
	or si, di			; si = -1 if EBDA as large as or larger than init image
	and ax, si			; ax = 0 if smaller EBDA, init image size - EBDA size + 1 else
	sub dx, ax
	jbe .booterror
	push dx
	mov ax, cs
	cmp dx, byte 50h		; memory >= 00500h belongs to us right now
	jb .booterror
	call movp			; copy us down

	push dx
	mov si, .proceedreloc1
	push si
	add dx, cx			; -> payload destination (behind destination image)
	add ax, cx			; -> source payload (behind source image)
	retf
.proceedreloc1:
	pop ss

		; Why can cart not push self?
		; We have to relocate our code first, then our payload because
		; if we where to relocate our code and payload together the payload
		; destination would overwrite the code doing the moving.
	pop cx				; -> EBDA/behind usable memory
	stc				; -1 (do not include MCB)
	sbb cx, ax			; length of payload
	call movp			; push little cart!
	stc				; +1 (include MCB)
	adc cx, ax			; -> EBDA
	pop ax				; length of EBDA
	mov dx, bx			; -> our final position
	sub dx, ax			; -> EBDA final position
	xchg ax, cx			; ax-> EBDA, cx = length
	call movp			; copy EBDA to final position (does nothing if no EBDA)
	cmp byte [ ss:ebdaflag ], 0
	je .noebdaupdate
	mov word [ es:0Eh ], dx		; update EBDA position
d4	call d4message
d4	asciz "EBDA relocated and position updated; press any key",13,10
d4	jmp short .d4_had_ebda
.noebdaupdate:
d4	call d4message
d4	asciz "No EBDA detected; press any key",13,10
d4 .d4_had_ebda:
d4	call d4pauseforkey
d4	call d4message
d4	asciz "Debugging input appears to work; press any key",13,10
d4	call d4pauseforkey

	mov cl, 6
	test dl, 0011_1111b		; these bits should not be set
	jnz .hardbooterror
	shr dx, cl
	mov word [ es:13h ], dx		; update memory size (KiB)
					; for this, we also had to compute our image's size in KiB

	mov ax, cs
	mov cx, resimagepsp_size_p
	lea dx, [bx+1]			; +1 to leave the image identification paragraph
	call movp			; install our image at its final position

d4	call d4message
d4	asciz "Image positioned at final location",13,10

	add cx, dx
	xor ax, ax
	xor di, di
	mov es, cx
	mov cx, ((kib(resimagepsp_size+16)*64)-(resimagepsp_size_p+1)) *8
	rep stosw			; clear this alignment

d4	call d4message
d4	asciz "Alignment initialised to zero; press any key",13,10
d4	call d4pauseforkey

		; Change to regular stack in the installed image
	cli
	mov ss, dx
	mov sp, stack_end		; stack pointer
	sti
	dec dx
	mov si, imageident
	xor di, di
	mov es, dx
	mov cx, 8
	rep cs movsw			; install image identification in paragraph before image
	push ss
	pop ds
	push ss
	pop es
	xor di, di
	mov cx, 128
	xor ax, ax
	rep stosw			; clear "PSP"

	mov word [execblk+2], 81h
	mov byte [82h], 0Dh
	mov byte [fileext], EXT_OTHER	; empty file name and command line as per N
.comentry:
%endif
	mov ax, ds
	mov word [ execblk+4 ], ax
	mov word [ execblk+8 ], ax
	mov word [ execblk+12 ], ax	; set up parameter block for exec command
	mov word [ pspdbg ], ax
%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jz .checkio
d4	call d4message
d4	asciz "Common initialisation, determining processor type now",13,10
	jmp .determineprocessor
.checkio:
%endif
		; Check for console input vs. input from a file or other device.
		; This has to be done early because MS-DOS seems to switch CON
		; to cooked I/O mode only then.
	mov ax, 4400h		; IOCTL get device information
	xor bx, bx		; StdIn
	mov dl, 83h		; default if 21.4400 fails
	int 21h
	test dl, 80h
	jz .inputfile
	clropt [internalflags], inputfile
	test dl, 3
	jz .inputdevice		; if not the console input
	clropt [internalflags], notstdinput
	mov byte [notatty], 0	; it _is_ a tty
.inputdevice:
.inputfile:
	mov ax, 4400h		; IOCTL get device information
	inc bx			; StdOut
	mov dl, 83h		; default if 21.4400 fails
	int 21h
	test dl, 80h
	jz .outputfile
	clropt [internalflags], outputfile
	test dl, 3
	jz .outputdevice	; if not the console output
	clropt [internalflags], notstdoutput
.outputdevice:
.outputfile:

		; Check DOS version
%if _VDD
	call isnt		; NTVDM ?
	jc .isnotnt		; no -->
	setopt [internalflags], runningnt
.isnotnt:
%endif

	mov ax, 3000h		; check DOS version
	int 21h
	xchg al, ah
	cmp ax, ver(3,31)	; MS-DOS version > 3.30 ?
	jb .notoldpacket	; no -->
	setopt [internalflags], oldpacket	; assume Int25/Int26 packet method available
.notoldpacket:
	push ax
	xor bx, bx		; preset to invalid value
	mov ax, 3306h
	int 21h
	or al, al		; invalid, DOS 1.x error -->
	jz .213306invalid
	cmp al, -1		; invalid
.213306invalid:
	pop ax
	je .useoldver
	test bx, bx		; 0.0 ?
	jz .useoldver		; assume invalid -->
	xchg ax, bx		; get version to ax
	xchg al, ah		; strange Microsoft version format
.useoldver:
	cmp ax, ver(7,01)	; MS-DOS version > 7.00 ?
	jb .notnewpacket	; no -->
	setopt [internalflags], newpacket| oldpacket	; assume both packet methods available
.notnewpacket:
%if _VDD
	testopt [internalflags], runningnt
	jz .novdd
	mov si, imsg.vdd	; ds:si-> ASCIZ VDD filename
	mov bx, imsg.dispatch	; ds:bx-> ASCIZ dispatching entry
	mov di, imsg.init	; es:di-> ASCIZ init entry
	clc			; !
	RegisterModule		; register VDD
	jc .novdd		; error ? -->
	mov word [hVdd], ax
	setopt [internalflags], ntpacket| oldpacket	; assume old packet method also available
.novdd:
%endif
.determineprocessor:
d4	call d4message
d4	asciz "Determining processor type",13,10

	mov cx, 0121h
	shl ch, cl
	jz .cpudone		; only 8086 uses higher bits of shift count -->

d4	call d4message
d4	asciz "Found 186+ processor",13,10
	inc byte [ machine ]	; 1
	push sp
	pop ax
	cmp ax, sp
	jne .cpudone		; 80186 pushes the adjusted value of sp -->

d4	call d4message
d4	asciz "Found 286+ processor",13,10
		; Determine the processor type.  This is adapted from code in the
		; Pentium<tm> Family User's Manual, Volume 3:  Architecture and
		; Programming Manual, Intel Corp., 1994, Chapter 5.  That code contains
		; the following comment:
		;
		; This program has been developed by Intel Corporation.
		; Software developers have Intel's permission to incorporate
		; this source code into your software royalty free.
		;
		; Intel 286 CPU check.
		; Bits 12-15 of the flags register are always clear on the
		; 286 processor in real-address mode.
		; Bits 12-15 of the FLAGS register are always set on the
		; 8086 and 186 processor.
	inc byte [ machine ]	; 2
	 pushf			; save IF
	pushf			; get original flags into ax
	pop ax
	or ax, 0F000h		; try to set bits 12-15
	and ax, ~0200h		; clear IF
	push ax			; save new flags value on stack
	popf			; replace current flags value; DI
	pushf			; get new flags
	pop ax			; store new flags in ax
	 popf			; restore IF
	test ax, 0F000h		; if bits 12-15 clear, CPU = 80286
	jz .cpudone		; if 80286 -->

d4	call d4message
d4	asciz "Found 386+ processor",13,10
		; Intel 386 CPU check.
		; The AC bit, bit #18, is a new bit introduced in the EFLAGS
		; register on the Intel486 DX cpu to generate alignment faults.
		; This bit cannot be set on the Intel386 CPU.
		;
		; It is now safe to use 32-bit opcode/operands.
cpu 386
	setopt [internalflags], has386
	inc byte [ machine ]	; 3

	mov bx, sp		; save current stack pointer to align
	and sp, ~3		; align stack to avoid AC fault
	pushfd			; push original EFLAGS
	pop eax			; get original EFLAGS
	mov ecx, eax		; save original EFLAGS in ECX

	xor eax, 40000h		; flip AC bit in EFLAGS
	and ax, ~0200h		; clear IF
	push eax		; put new EFLAGS value on stack
	popfd			; replace EFLAGS value; DI
	pushfd			; get new EFLAGS
	pop eax			; store new EFLAGS value in EAX
	mov ax, cx		; ignore low bits (including IF)
	cmp eax, ecx
	je .cpudone_stack_eax_equals_ecx	; if 80386 -->

d4	call d4message
d4	asciz "Found 486+ processor",13,10
		; Intel486 DX CPU, Intel487 SX NDP, and Intel486 SX CPU check.
		; Checking for ability to set/clear ID flag (bit 21) in EFLAGS
		; which indicates the presence of a processor with the ability
		; to use the CPUID instruction.
	inc byte [ machine ]	; 4
	mov eax, ecx		; get original EFLAGS
	xor eax, 200000h	; flip ID bit in EFLAGS
	and ax, ~0200h		; clear IF
	push eax		; save new EFLAGS value on stack
	popfd			; replace current EFLAGS value; DI
	pushfd			; get new EFLAGS
	pop eax			; store new EFLAGS in EAX
	mov ax, cx		; ignore low bits (including IF)

.cpudone_stack_eax_equals_ecx:
	push ecx
	popfd			; restore AC,ID bits in EFLAGS
	mov sp, bx		; restore sp

	cmp eax, ecx		; check if it's changed
	je .cpudone		; if it's a 486 (can't toggle ID bit) -->

d4	call d4message
d4	asciz "Found processor with CPUID support",13,10
		; Execute CPUID instruction.
cpu 486			; NASM (at least 2.10rc1) handles cpuid itself as a
			;  586+ instruction, but we know better. So this
			;  part is declared for 486 compatibility, and only
			;  the cpuid instructions are emitted with 586
			;  compatibility to appease NASM.
%if 0
d4	call d4message
d4	asciz "CPUID will NOT be executed, to work around official DOSBox releases",13,10
d4	jmp .cpudone
%endif
	xor eax, eax		; set up input for CPUID instruction
d4	call d4message
d4	asciz "Executing CPUID 0",13,10
	  [cpu 586]
	 cpuid
	  __CPU__
d4	call d4message
d4	asciz "CPUID 0 executed",13,10
	cmp eax, byte 1
	jb .cpudone		; if 1 is not a valid input value for CPUID
	xor eax, eax		; otherwise, run CPUID with eax = 1
	inc eax
d4	call d4message
d4	asciz "Executing CPUID 1",13,10
	  [cpu 586]
	 cpuid
	  __CPU__
d4	call d4message
d4	asciz "CPUID 1 executed",13,10
%if _MMXSUPP
	test edx, 80_0000h
	setnz byte [has_mmx]
%endif

	mov al, ah
	and al, 0Fh		; bits 8..11 are the model number
	cmp al, 6
	jb .below686		; if < 6
	mov al, 6		; if >= 6, set it to 6
.below686:
	mov byte [ machine ], al; save machine type (486, 586, 686+)

.cpudone:
cpu 8086
d4	call d4message
d4	asciz "Determining floating-point unit",13,10

		; Next determine the type of FPU in a system and set the mach_87
		; variable with the appropriate value.  All registers are used by
		; this code; none are preserved.
		;
		; Coprocessor check.
		; The algorithm is to determine whether the floating-point
		; status and control words can be written to.  If not, no
		; coprocessor exists.  If the status and control words can be
		; written to, the correct coprocessor is then determined
		; depending on the processor ID.  The Intel 386 CPU can
		; work with either an Intel 287 NDP or an Intel 387 NDP.
		; The infinity of the coprocessor must be checked
		; to determine the correct coprocessor ID.
	mov al, byte [ machine ]
	mov byte [ mach_87 ], al	; by default, set mach_87 to machine
	inc byte [ has_87 ]
	cmp al, 5			; a Pentium or above always will have a FPU
	jae .fpudone
	dec byte [ has_87 ]		; assume no FPU

	fninit				; reset FPU
	mov al, -1			; initialise with a non-zero value
	push ax
	mov bx, sp		; (assumes ds == ss)
	fnstsw word [bx]		; save FP status word
	pop ax				; retrieve it
	test al, al
	jnz .fpudone			; if no FPU present

		; al = 0 here
	push ax
	fnstcw word [bx]		; save FP control word
	pop ax				; retrieve it
	and ax, 103Fh			; see if selected parts look OK
	cmp ax, byte 3Fh
	jne .fpudone			; if no FPU present
	inc byte [ has_87 ]		; there's an FPU

		; If we're using a 386, check for 287 vs. 387 by checking whether
		; +infinity = -infinity.
	cmp byte [ machine ], 3
	jne .fpudone			; if not a 386
cpu 386
	fld1				; must use default control from FNINIT
	fldz				; form infinity
	fdivp ST1			; 1 / 0 = infinity
	fld ST0
	fchs				; form negative infinity
	fcompp				; see if they are the same and remove them
	fstsw ax
	sahf				; look at status from FCOMPP
	jne .fpudone			; if they are different, then it's a 387
	dec byte [ mach_87 ]		; otherwise, it's a 287
cpu 8086
.fpudone:

%if _ONLY386
	testopt [internalflags], has386
	jnz @F				; okay -->
 %if _BOOTLDR
	testopt [internalflags], nodosloaded
	lahf				; remember status
	 push cs
	 pop ds
	 push cs
	 pop es				; fix segments
 %endif
	mov dx, imsg.no386
	call putsz			; display the error
 %if _BOOTLDR
	sahf
	jnz .booterror			; abort for loader -->
 %endif
	mov ax, 4C01h
	int 21h				; abort our process

@@:
%elif _ONLYNON386
	testopt [internalflags], has386
	jz @F				; okay -->
 %if _BOOTLDR
	push ds
	 push cs
	 pop ds
	 push cs
	 pop es				; fix segments
 %endif
	mov dx, imsg.386
	call putsz			; display the warning
 %if _BOOTLDR
	pop ds				; restore segment
 %endif
@@:
%endif

		; Determine which patch table to use, then patch
		; out either the 386+ or non-386 code as appropriate.
	mov si, patch_386_table		; table of patches to set for 386+
%if __patch_386_table_method == 1
	mov cx, patch_386_table_size_w
%endif
	testopt [internalflags], has386
%if __patch_386_table_method == 1
	jnz .patch1			; set these patches (CPU is 386+) -->
%else
	jnz .patch2			; set these patches (CPU is 386+) -->
%endif
%ifn _ONLYNON386
	mov byte [..@patch_no386_ds], 3Eh	; write a ds prefix
	mov byte [..@patch_no386_iret], 0CFh	; write an iret instruction
%endif
	mov si, patch_no386_table	; table of patches to set for 16-bit CPU
%if __patch_no386_table_method == 1
	mov cx, patch_no386_table_size_w
 %if __patch_386_table_method == 2
	jmp short .patch1		; skip .patch2 code -->
 %endif
%endif

		; Complicated table patch code.
%if __patch_no386_table_method == 2 || __patch_386_table_method == 2
.patch2:
	xor ax, ax			; initialise ah
.looppatch2:
	BOOTLDR_cs lodsb
	add bx, ax			; skip number of bytes to skip
	cmp al, 255			; really repositioning?
	jne .l2patch			; no -->
	xchg ax, bx			; (to preserve ah)
	BOOTLDR_cs lodsw		; ax = new address
	xchg ax, bx			; bx = new address
.l2patch:
	BOOTLDR_cs lodsb
	mov cx, ax			; cx = number of bytes to patch
	jcxz .patchesdone		; end of table -->
.l2patchbyte:
	mov byte [bx], 90h		; patch
	inc bx
	loop .l2patchbyte		;  as many bytes as specified
	jmp short .looppatch2
%endif

		; Simple table patch code.
%if __patch_386_table_method == 1 || __patch_no386_table_method == 1
.patch1:
	jcxz .patchesdone
.looppatch1:
	BOOTLDR_cs lodsw		; load address of patch
	mov bx, ax
	mov byte [bx], 90h		; patch
	loop .looppatch1
%endif
.patchesdone:

%if _BOOTLDR
	testopt [internalflags], nodosloaded
	jz .commandline
d4	call d4message
d4	asciz "386-related patches applied, boot initialisation proceeding",13,10

		; Set up interrupt vectors.
	mov cx, inttab_number
	mov si, inttab
	mov di, intsave
.bootintloop:

	ss lodsb
	xor bx, bx
	mov ds, bx
	mov bl, al
	add bx, bx
	add bx, bx
	push word [ bx+2 ]
	push word [ bx ]	; get vector
	pop word [ ss:di ]
	pop word [ ss:di+2 ]	; store it
	scasw
	scasw		; add di, 4
%if _DEBUG			; vectors are set only when debuggee runs
	lodsw		; add si, 2
%else
	ss lodsw		; get address
	mov word [ bx+2 ], ss
	mov word [ bx ], ax	; set interrupt vector
%endif
	loop .bootintloop

		; Might be running as DOS inside DOSEMU
%if _DOSEMU
	mov ax, 0F000h
	mov es, ax
	mov di, 0FFF5h
	mov si, imsg.dosemudate
	mov cx, 4
	repe cs cmpsw		; running in DosEmu?
	jne .dosemuchecked
	setopt [internalflags], nohook2F
.dosemuchecked:
%endif
	push ss
	pop ds
	push ss
	pop es

d4	call d4message
d4	asciz "Jumping to final boot initialisation code",13,10
	jmp initcont.resized
%endif
.commandline:

		; Interpret switches and erase them from the command line.
	mov ax, 3700h			; get switch character
	mov dl, '/'			; preset with default value
	int 21h
	mov byte [ switchar ], dl
	cmp dl, '/'
	jne .notslash
	mov byte [ swch1 ], dl
.notslash:
	mov si, DTA+1
.blankloop:
	lodsb
	cmp al, 32
	je .blankloop
	cmp al, 9
	je .blankloop

		; Process the /? switch (or the [switchar]? switch).
		; If switchar != / and /? occurs, make sure nothing follows.
	cmp al, dl
	je .switch		; if switch character -->
	cmp al, '/'
	jne .noswitches		; if not the help switch -->
	mov al, byte [ si ]
	cmp al, '?'
	jne .noswitches		; if not /?
	mov al, byte [ si+1 ]
	cmp al, 32
	je .help		; if nothing after /?
	cmp al, 9
	je .help		; ditto
	cmp al, 13
	jne .noswitches		; if something after /? -->

		; Print a help message
.help:	mov dx, imsg.help	; command-line help message
	call putsz		; print string
	mov ax, 4C00h
	int 21h			; done

		; Do the (proper) switches.
.switch:lodsb
	cmp al,'?'
	je .help		; if -?

		; Other switches may go here.
	mov [ imsg.invalidswitch_a ], al
	mov dx, imsg.invalidswitch	; Invalid switch
	call putsz		; print string
	mov ax, 4C01h		; Quit and return error status
	int 21h

.noswitches:
		; Feed the remaining command line to the 'n' command.
	dec si
	lodsb
	call nn			; process the rest of the line

		; Set up interrupt vectors.
	mov cx, inttab_number
	mov si, inttab
	mov di, intsave
.intloop:
	lodsb
	mov ah, 35h
	int 21h			; get vector
	mov word [ di+0 ], bx
	mov word [ di+2 ], es	; store it
	scasw
	scasw		; add di, 4
%if _DEBUG			; vectors are set only when debuggee runs
	lodsw		; add si, 2
%else
	xchg ax, dx
	lodsw			; get address
	xchg ax, dx
	mov ah, 25h		; set interrupt vector
	int 21h
%endif
	loop .intloop

%if _MCB
	mov ah, 52h		; get list of lists
	int 21h
	mov ax, word [ es:bx-2 ]; start of MCBs
	mov word [ wMCB ], ax
%endif
	mov ah, 34h
	int 21h
	mov word [ pInDOS+0 ], bx
	mov word [ pInDOS+2 ], es
%if _PM
	mov word [ InDosSegm ], es
%endif

		; get address of DOS swappable DATA area
		; to be used to get/set PSP and thus avoid DOS calls
		; will not work for DOS < 3
%if _USESDA
	push ds
	mov ax, 5D06h
	int 21h
	mov ax, ds
	pop ds
	jc .noSDA
	mov word [ pSDA+0 ], si
	mov word [ pSDA+2 ], ax
 %if _PM
	mov word [ SDASegm ], ax
 %endif
.noSDA:
%endif


%if _PM
		; Windows 9x and DosEmu are among those hosts which handle some
		; V86 Ints internally without first calling the interrupt chain.
		; This causes various sorts of troubles and incompatibilities;
		; in our case, hooking interrupt 2Fh would not intercept calls
		; made to the DPMI interface because the host sees them first.
 %if _WIN9XSUPP
	mov ax, 1600h		; running in a Win9x DOS box?
	int 2Fh
	cmp al, 4
	jge .no2Fhook		; this is intentionally a signed comparison!
 %endif
 %if _DOSEMU
	mov ax, 0F000h
	mov es, ax
	mov di, 0FFF5h
	mov si, imsg.dosemudate
	mov cx, 4
	repe cmpsw		; running in DosEmu?
	je .no2Fhook
 %endif
 %if _WIN9XSUPP || _DOSEMU
	jmp short .dpmihostchecked
.no2Fhook:
	setopt [internalflags], nohook2F
.dpmihostchecked:
 %endif
%endif
		; shrink to required resident size
	push ds
	pop es
..@bootentrystack:
	mov sp, (..@tempstack+SECTIONFIXUP)&~1	; temporary stack in an area that belongs to us
	jmp initcont


	numdef _USE_FINAL__
%assign __CHECK_TEMPSTACK ..@tempstack+SECTIONFIXUP
%if __NASM_VERSION_ID__ >= 020A0000h && __USE_FINAL__
%final %endif
%final  %error ..@tempstack (%[__CHECK_TEMPSTACK]) > \
		resident size (%[__CHECK_RESIDENTSIZE]), stack destroys MCB
%final %if __CHECK_TEMPSTACK > __CHECK_STACKEND
%final %assign __CHECK_RESIDENTSIZE resimagepsp_size
%endif
